#include <WindowsConstants.au3>
#include <StaticConstants.au3>
#include <GUIConstantsEx.au3>
#include <EditConstants.au3>
#include <ComboConstants.au3>
#include <GuiStatusBar.au3>
#include <Timers.au3>
#include <Array.au3>

Opt("GUIOnEventMode", 1)

Global Const $CmbWinstateNorm = @SW_SHOWNORMAL & " - Normal Window"
Global Const $CmbWinstateMin = @SW_SHOWMINNOACTIVE & " - Minimized"
Global Const $CmbWinstateMax = @SW_SHOWMAXIMIZED & " - Maximized"

#region - GUI

$GUI = GUICreate("LNKEditorGUI - Windows Shortcut LNK File Editor", 800, 640, -1, -1, BitOr($GUI_SS_DEFAULT_GUI,$WS_MAXIMIZEBOX,$WS_SIZEBOX ), $WS_EX_ACCEPTFILES)
GUISetOnEvent($GUI_EVENT_CLOSE, '_exit')
GUISetOnEvent($GUI_EVENT_DROPPED, "On_Drop_InFilename")
GUISetFont(10)

$Status = _GUICtrlStatusBar_Create($GUI)

GUICtrlCreateLabel("File:", 4, 6, 36, 24)
$inFilename = GUICtrlCreateInput("", 36, 4, 672, 24)
GUICtrlSetState(-1, $GUI_DROPACCEPTED)

$btBrowseForFile = GUICtrlCreateButton("Browse...", 712, 4, 84, 24)
GUICtrlSetOnEvent(-1, '_btBrowseForFile')

$btOpenFile = GUICtrlCreateButton("Load LNK File", 20, 32, 370, 28)
GUICtrlSetOnEvent(-1, '_btOpenFile')
GUICtrlSetResizing($btOpenFile, $GUI_DOCKLEFT)

$btSaveFile = GUICtrlCreateButton("Save LNK File", 410, 34, 370, 28)
GUICtrlSetOnEvent(-1, '_btSaveFile')
GUICtrlSetResizing($btSaveFile, $GUI_DOCKRIGHT)

GUICtrlCreateLabel("Target EXE", 4, 80, 172, 24)
$inTargetEXE = GUICtrlCreateInput("", 4, 104, 792, 24)
GUICtrlSetState(-1, $GUI_DROPACCEPTED)

GUICtrlCreateLabel("Target Arguments", 4, 148, 172, 24)
$editTargetArgs = GUICtrlCreateEdit("", 4, 172, 792, 96, $ES_MULTILINE)
GUICtrlSetState(-1, $GUI_DROPACCEPTED)

GUICtrlCreateLabel("Working Dir", 4, 288, 172, 24)
$inWorkingDir = GUICtrlCreateInput("", 4, 312, 792, 24)
GUICtrlSetState(-1, $GUI_DROPACCEPTED)

GUICtrlCreateLabel("Window State", 4, 356, 172, 24)
$cmbWindowState = GUICtrlCreateCombo("", 4, 380, 792, 24, $CBS_DROPDOWNLIST)
GUICtrlSetData(-1, $CmbWinstateNorm & "|" & $CmbWinstateMin & "|" & $CmbWinstateMax, $CmbWinstateNorm) ; add other item snd set a new default

GUICtrlCreateLabel("Icon File", 4, 424, 172, 24)
$inIconFile = GUICtrlCreateInput("", 4, 448, 650, 24)
GUICtrlSetState(-1, $GUI_DROPACCEPTED)

GUICtrlCreateLabel("Icon Index", 680, 424, 172, 24)
$inIconIndex = GUICtrlCreateInput("", 674, 448, 112, 24)

GUICtrlCreateLabel("Comment", 4, 492, 172, 24)
$editComment = GUICtrlCreateEdit("", 4, 516, 792, 96, $ES_MULTILINE)
GUICtrlSetState(-1, $GUI_DROPACCEPTED)

GUISetState(@SW_SHOW, $GUI)

#endregion - GUI

If $CmdLine[0] > 0 Then
	;MsgBox(0,0,$CmdLine[1])
	GUICtrlSetData($inFilename, $CmdLine[1])
	_btOpenFile()
EndIf

While 1
	Sleep(100)
WEnd

;---------------------------------------------------------------
Func StatusBarNotify($msg)
		_GUICtrlStatusBar_SetText($Status, $msg)
		_Timer_SetTimer($GUI, 5000, "_ClearStatusBar")
EndFunc

;---------------------------------------------------------------
Func _ClearStatusBar($hWnd, $msg, $iIDTimer, $dwTime)
    #forceref $hWnd, $msg, $iIDTimer, $dwTime
    _GUICtrlStatusBar_SetText($Status, "")
    _Timer_KillTimer($hWnd, $iIDTimer)
EndFunc

;---------------------------------------------------------------
Func _btBrowseForFile()
	Local $var = FileSaveDialog("Choose a LNK File Name", "D:\", "LNK Shortcuts (*.lnk)", 2) ; option 2 = dialog remains until valid path/file selected
	If @error Then
		;MsgBox(4096, "", "No File(s) chosen")
	Else
		$var = StringReplace($var, "|", @CRLF)
		GUICtrlSetData($inFilename, $var)
	EndIf
EndFunc

;---------------------------------------------------------------
Func On_Drop_InFilename()
	If ( (@GUI_DropId = $inFilename) OR (@GUI_DropId = $inTargetEXE) ) Then
    	GUICtrlSetData(@GUI_DropId, @GUI_DragFile)
	EndIf
	If ( (@GUI_DropId = $inFilename) AND (@GUI_DragFile <> "") ) Then
		OpenFile(@GUI_DragFile)
	EndIf
EndFunc

;---------------------------------------------------------------
Func _btOpenFile()

	Local $filename = GUICtrlRead($inFilename)
	If $filename = "" Then
		;_btBrowseForFile()
		;$filename = GUICtrlRead($inFilename)
		StatusBarNotify("ERROR: Trying to open file but no file specified.")
		MsgBox(0,"ERROR","Trying to open file but no file specified.")
	Else
		OpenFile($filename)
	EndIf
EndFunc

;---------------------------------------------------------------
Func OpenFile($filename)
	Local $lnkArray = FileGetShortcut($filename)
	If Not @error Then
		;_ArrayDisplay($lnkArray)
	Else
		StatusBarNotify("ERROR: Unable to open file.")
		MsgBox(0,"ERROR","Unable to open file, please check the file name.")
		Return
	EndIf
	GUICtrlSetData($inTargetEXE, $lnkArray[0])
	GUICtrlSetData($editTargetArgs, $lnkArray[2])
	GUICtrlSetData($inWorkingDir, $lnkArray[1])
	GUICtrlSetData($inIconFile, $lnkArray[4])
	GUICtrlSetData($inIconIndex, $lnkArray[5])
	GUICtrlSetData($editComment, $lnkArray[3])
	If($lnkArray[6] = @SW_SHOWNORMAL) Then
		GUICtrlSetData($cmbWindowState, $CmbWinstateNorm)
	ElseIf($lnkArray[6] = @SW_SHOWMINNOACTIVE) Then
		GUICtrlSetData($cmbWindowState, $CmbWinstateMin)
	ElseIf($lnkArray[6] = @SW_SHOWMAXIMIZED) Then
		GUICtrlSetData($cmbWindowState, $CmbWinstateMax)
	EndIf
	StatusBarNotify("Successfully loaded file: " & $filename)
EndFunc

;---------------------------------------------------------------
Func _btSaveFile()

	$filename = GUICtrlRead($inFilename)
	If $filename = "" Then
		StatusBarNotify("ERROR: Trying to save but no file name specified.")
		MsgBox(0,"ERROR","Trying to save but no file name specified.")
		Return
	EndIf

	Local $WinStateToWrite
	Switch GuiCtrlRead($cmbWindowState)
	    Case $CmbWinstateNorm
	    	$WinStateToWrite = @SW_SHOWNORMAL
	    Case $CmbWinstateMin
	    	$WinStateToWrite = @SW_SHOWMINNOACTIVE
	    Case $CmbWinstateMax
	    	$WinStateToWrite = @SW_SHOWMAXIMIZED
	    Case Else
	    	$WinStateToWrite = @SW_SHOWNORMAL
	EndSwitch

	$saveResult = FileCreateShortcut(GuiCtrlRead($inTargetEXE), $filename, GuiCtrlRead($inWorkingDir), GuiCtrlRead($editTargetArgs), GuiCtrlRead($editComment), GuiCtrlRead($inIconFile), "", GuiCtrlRead($inIconIndex), $WinStateToWrite)
	If($saveResult) Then
		StatusBarNotify("Successfully saved file to: " & $filename)
	Else
		StatusBarNotify("ERROR: Unable to save file, please check the file name and values.")
		MsgBox(0,"ERROR","Unable to save file, please check the file name and values.")
		EndIf

EndFunc

;---------------------------------------------------------------
Func _exit()
	Exit
EndFunc

;---------------------------------------------------------------

